#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#include "incl.h"
#include "cipl.h"

int main(int argc, char *argv[]) {
  int i, j, max;
  int arr[2]={1200,2400};
  double diff;
  THEADER *it, *ot, *temp, *temp1, *temp2;
  DATA *ID;
  
  HIPL_Setmemory(4096);
  
  it=(THEADER *)malloc(sizeof(THEADER));
  ot=(THEADER *)malloc(sizeof(THEADER));
  temp=(THEADER *)malloc(sizeof(THEADER));
  temp1=(THEADER *)malloc(sizeof(THEADER));
  
  ID=(DATA *)malloc(sizeof(DATA));
  HIPL_Initialise(it,argv[1],0,0,ID);
  HIPL_Initialise(ot,NULL,1,0,ID);
  HIPL_Initialise(temp,NULL,1,0,ID);
  HIPL_Initialise(temp1,NULL,1,0,ID);
  
  HIPL_AllocateMem(it);
  HIPL_AllocateMem(ot);
  HIPL_AllocateMem(temp);
  HIPL_AllocateMem(temp1);
  
  CIPL_rgbtohsi(it, temp); 
  do {
    max = HIPL_Getpart(temp);
    if (max < 0) {
      HIPL_Error("Hue Filtering");
      exit(1);
    }
    for (i=0; i<max; i++) {
      for (j=0; j<temp->img.COLS; j++) {
	diff = fabs(temp->jarr[i][j] - atoi(argv[3]));
	if (diff <= 100)
	  diff = 1.0;
	else
	  diff /= 100.0;
	if (diff < 1.0)
	  diff = 1.0;
	temp1->iarr[i][j] = (int)(temp->iarr[i][j] / diff);
	temp1->jarr[i][j] = temp->jarr[i][j];
	temp1->karr[i][j] = temp->karr[i][j];
      }
    }

    max = HIPL_Putpart(temp1);
    if (max<0) {
      HIPL_Error("Hue Filter Output");
      exit(1);
    }
    if (temp1->P.nleft == 0)
      max = -1;
  } while (max >= 0);

  HIPL_Refresh(temp1, 0);
  CIPL_hsitorgb(temp1, ot);
  HIPL_Refresh(ot, 0);

  HIPL_StoreResult(argv[2], ot);

  HIPL_Closeall(it);
  HIPL_Closeall(ot);
  HIPL_Closeall(temp);
  HIPL_Closeall(temp1);
  
  exit(0);
}
